
--[[
LuaMainframe is the work of Alex Glynn, alexglynn@gmail.com (AKA, Glynnder)
http://www.pspro.co.uk
Copyright, Alex Glynn.
File browser still currently uses much code by Nevyn
]]


  
if skin == blue then
bgimg = "image/blue/imgbg.png"
elseif skin == red then
bgimg = "image/rd/imgbg.png"
elseif skin == green then
bgimg = "image/grn/imgbg.png"
elseif skin == white then
bgimg = "image/wht/imgbg.png"
end



x = 0
y = 0
Mainframe = {  
  currentIndex = 1,
  drawStartIndex = 1,
  status = "",
  res = {
    genericFolderIcon = Image.load("image/fldr.png"),
    genericAppIcon = Image.load("image/app.png"),
    genericimgIcon = Image.load("image/img.png"),
    genericIcon = Image.load("image/oth.png"),
    pspAppIcon = genericAppIcon,
    arrowIcon = Image.load("image/gameindicator.png"),
    backgroundImage = Image.load(bgimg)
    },
  colors = {
    bg = Color.new(230, 230, 230),
    text = Color.new(0 , 153, 255)
  },
  contents = {},
  cwd = ""
}

eer = Image.load("image/selected.png")

  showpng = false  
purple =  Color.new(167, 29, 226)
dblue = Color.new(0, 0, 255)
red = Color.new(230, 0, 0)
pink = Color.new(255, 0 , 153)
blue = Color.new(0 , 153, 255)
orange = Color.new(255, 102, 0)
gray = Color.new(153, 153, 153)
black = Color.new(0 , 0 , 0)
white = Color.new(255, 255, 255)
green = Color.new(0 , 255, 0)
function Mainframe:new()
   c = {} 
   setmetatable(c, self) 
   self.__index = self 
   return c
end

function Mainframe:renderIconsForCurrentDirectory()
  self.contents = System.listDirectory()
  self.cwd = System.currentDirectory()  
  table.sort(self.contents, function (a, b) return a.name < b.name end)
  done = false
  while not done do -- filter out unwanted files
    for idx,file in self.contents do
      if string.sub(file.name,1,1) == "." and not string.find(file.name, "icon.png") then
        table.remove(self.contents, idx)
        break
      end
      
      if idx == table.getn(self.contents) then
        done = true
      end
    end
  end

  for idx, file in self.contents do
    -- defaults
    curfile = self.contents[i]
    file.icon = nil
    file.render = nil
    file.ftype = "none"
    file.dprender = nil
    file.dp = nil

      -- set icon
    if file.directory then
      -- traverse and assign correct icon and type
      System.currentDirectory(file.name)
      subdirconts = System.listDirectory()
      curri = self.currentIndex

      for subidx, subfile in subdirconts do
        if string.lower(subfile.name) == "index.lua" then
          file.icon = self.res.genericAppIcon
          file.ftype = "appdir"
        end
      end
      for subidx, subfile in subdirconts do
        if string.lower(subfile.name) == "icon.png" then
          file.icon = Image.load(subfile.name)
        end
      end
 --     self.currentIndex
      for subidx, subfile in subdirconts do
        if string.lower(subfile.name) == "displaypic.png" then
    --      if subdir == self.currentIndex then
file.dp = Image.load(subfile.name)
      --  end
       end
        end
      System.currentDirectory(self.cwd)
      
      if file.icon == nil then
        file.icon = self.res.genericFolderIcon
      end
      if file.dp == nil then
        file.dp = genericGamePic
      end
      if file.ftype == "none" then
        file.ftype = "dir"
      end
    else -- is a file
     
      -- DEFINE AND SET FILE TYPES
      if string.lower(string.sub(file.name, -4)) == ".lua" then
        file.icon = self.res.genericAppIcon
        file.ftype = "app"
      elseif string.lower(string.sub(file.name, -4)) == ".PBP" then
        file.icon = self.res.pspAppIcon
        file.ftype = "pbp"
      elseif string.lower(string.sub(file.name, -4)) == ".png" then
        file.icon = self.res.genericimgIcon
        file.ftype = "img"
              elseif string.lower(string.sub(file.name, -4)) == ".jpg" then
        file.icon = self.res.genericimgIcon
        file.ftype = "img"
      else
        file.icon = self.res.genericIcon
      end
    end -- setting icon
--self.currentIndex   
    -- render
          if file.dp == nil then
        file.dp = eer
      end
    file.render = Image.createEmpty(162, 32)
   file.dprender = Image.createEmpty(198, 98)

    file.render:clear()
    file.dprender:clear()

    file.render:blit(0,0,file.icon)
    file.dprender:blit(0, 0, file.dp)
    file.render:print(36, 12, file.name, self.colors.text)
    
  end -- loop through dir()
end -- function call

function Mainframe:render()

screen:blit(0,0, self.res.backgroundImage)

  local x = 14
  local y = 8
  local dirName = string.gsub(string.sub(self.cwd,5), "/", " > ")  
  y = y + 8 + 14

  for i=self.drawStartIndex, math.min(self.drawStartIndex + (272-12)/36 -2, table.getn(self.contents)) do
    curfile = self.contents[i]
    if i == self.currentIndex then
      screen:blit(x+285,y+80,self.res.arrowIcon)
      screen:blit(58, 116, curfile.dprender)
    end
    screen:blit(x+200+99, y+65, curfile.render)
    y = y + 32 + 4
  end

      datef = os.date("*t", os.time())
      f = function(s) 
        if s < 10 then
          return "0"..s
        else return s end
      end     
      screen:print(310, 4, f(datef.hour)..":"..f(datef.min)..":"..f(datef.sec))
        screen:print(445, 4, tostring("".. System.powerGetBatteryLifePercent()) .. "%")
  -- created by Glynnder
  
if diskmode == true then
        screen:blit(4,2, active)
end
-- screen.flip()
-- else
    screen:blit(0, 0, showpic)
  screen.flip()
  --end
end

function Mainframe:cd(newdir)
  self.currentIndex = 1
  self.drawStartIndex = 1
  System.currentDirectory(newdir)
  self.cwd = System.currentDirectory()
  self:renderIconsForCurrentDirectory() -- (hopefully expected) side effect.
end

function Mainframe:action(entry)
  if entry.ftype == "dir" then
    self:cd(entry.name)
    self:render()
      showpng = false
  elseif entry.ftype == "appdir" then
    self.status = ""
    System.currentDirectory(entry.name)
    dofile("index.lua")
    screen.waitVblankStart(10)
    System.currentDirectory("..")
    self:render()
      showpng = false
  elseif entry.ftype == "app" then
    dofile(entry.name)
    screen.waitVblankStart(10)
    self:render()
    elseif entry.ftype == "img" then

showpng = true  

else

x = 0
y = 0
  showpng = false
    self.status = "This is not a valid .lua or image file"
    self:render()
  end
  if showpng  == true then
screen:clear()
    imghp = Image.load(entry.name)
    showpic:blit(x,y, imghp)
    self:render()
    else showpic:clear()
    self:render()
    end
    showpng = false
end 

function Mainframe:filemenu(entry)
  self:action(entry) -- placeholder
end

function Mainframe:event(e)
showpic:clear()
  pad = e.value
  keyin = e.value
    dx = pad:analogX()
 if math.abs(dx) > 32 then

    x = x + dx / 64

  end

  dy = pad:analogY()

  if math.abs(dy) > 32 then
 
   y = y + dy / 64

  end
  if keyin:up() then
    if self.currentIndex > 1 then
      self.currentIndex = self.currentIndex - 1
      self.drawStartIndex = math.min(self.currentIndex, self.drawStartIndex)
    end
    self:render(contents)
  elseif keyin:down() then
    if self.currentIndex < table.getn(self.contents) then
      self.currentIndex = self.currentIndex + 1
      if (self.currentIndex - self.drawStartIndex) > ((272-12)/40 -2) then
        self.drawStartIndex = self.drawStartIndex + 1
      end
    end
    self:render(contents)
  elseif keyin:cross() then
    self:filemenu(mf.contents[self.currentIndex])
  elseif keyin:right() then
    if self.contents[self.currentIndex].ftype == "dir" then
      self:action(self.contents[self.currentIndex])
    else
      self:filemenu(self.contents[self.currentIndex])
    end
    elseif keyin:r() then
    screen.waitVblankStart(10)
        dofile(hbloc)
  elseif keyin:left() or keyin:triangle() then
    self:cd("..")
    self:render()
    elseif keyin:select() then
    isHelpThere = true
    screen.waitVblankStart(10)    
    while isHelpThere do
      screen:clear(Color.new(20, 126, 180))
      screen:print(120, 1, "Help: Press select to return.", Color.new(219, 219, 250)) 
      screen:print(10, 21, "Disclaimer: I did not make the script for the file browser", Color.new(219, 219, 250)) 
      screen:print(10, 31, "function in this program, it executes files in much the", Color.new(219, 219, 250)) 
      screen:print(10, 41, "same way as Lowser by Nevyn.", Color.new(219, 219, 250)) 
      screen:print(10, 51, "=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=", Color.new(219, 219, 250)) 
      screen:print(10, 71, "Controls: Press start to restart. (If you have enabled it)", Color.new(219, 219, 250))
      screen:print(1, 81, "        Press select to enter and leave the help screen.", Color.new(219, 219, 250)) 
      screen:print(1, 91, "        Press square to go to the home screen", Color.new(219, 219, 250))
      screen:print(1, 101, "        Press cross on a lua app to execute it.", Color.new(219, 219, 250))
      screen:print(1, 111, "        Press up and down to browse through the files.", Color.new(219, 219, 250))
      screen:print(1, 121, "        Press L to activate USB.", Color.new(219, 219, 250))
      screen:print(1, 131, "        Press R to exec favourite app (set in settings.ini).", Color.new(219, 219, 250))
	  screen:print(1, 141, "        Use cross and triangle to navigate through folders.", Color.new(219, 219, 250))
      screen:print(10, 151, "=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=", Color.new(219, 219, 250))
      screen:print(10, 171, "Features: interfaceLua features a time and date display,", Color.new(219, 219, 250))
      screen:print(10, 181, "a game picture, a battery % and time remaining display", Color.new(219, 219, 250))      
      screen:print(10, 191, "a battery charging indicator, an image viewer, homebrew", Color.new(219, 219, 250)) 
      screen:print(10, 201, "quick launch, irfs, a settings screen, a home page, ", Color.new(219, 219, 250))     
	  screen:print(10, 211, "a beautiful interface and much, much more, the list", Color.new(219, 219, 250))     
	  screen:print(10, 221, "is almost endless...", Color.new(219, 219, 250))     
	  screen:print(10, 231, "=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=", Color.new(219, 219, 250))  
	  screen:print(10, 241, "Thank you very much for using and downloading my program", Color.new(219, 219, 250))  
	  screen:print(200, 255, "~Glynnder", Color.new(219, 219, 250))      
      helptherekey = Controls.read()
      screen.waitVblankStart(15)
      isHelpThere = not helptherekey:select()
      screen.waitVblankStart()
      screen:flip()
      end
      
    end
    
    self:render()
    screen.waitVblankStart(navspeed)
end


MainframeController = { 
  responders = {}
}

function MainframeController:new() -- This is just a copypaste of Shines code...
   c = {} 
   setmetatable(c, self) 
   self.__index = self 
   return c
end

function MainframeController:addResponder(responder)
  table.insert(self.responders, responder)
end

function MainframeController:dispatchEvent(e)
  self.responders[table.getn(self.responders)](e)
end

--          Main app
mf = Mainframe:new() 

mf:cd("ms0:/psp/photo")
mf:render()

controller = MainframeController:new()
controller:addResponder(function (e) mf.status = "No responder! message:"..e.value; Mainframe:render(); end)
controller:addResponder(function (e) mf:event(e); end)


local lastkeyin = Controls.read()

while true do

  if diskmode == true then
  System.usbDiskModeActivate()
  else
  System.usbDiskModeDeactivate()
  end

  keyin = Controls.read()
  pad = Controls.read()

if autoscroll ~= true then
  if pad ~= lastkeyin then
    event = { type="key", value=keyin }
    controller:dispatchEvent(event)
  end
  else    event = { type="key", value=keyin }
    controller:dispatchEvent(event)
    end
  
if pad:square() then
      System.currentDirectory(appsDir .. "/interfaceLua")
      dofile("home.lua")
      break
  end
  
    if pad:l() and diskmode == false then
  diskmode = true
  screen.waitVblankStart(20)
  elseif pad:l() and diskmode == true then
  diskmode = false
  screen.waitVblankStart(20)
  end
  
  if start2quit == true then
  if pad:start() then
  break
  end
  end

  lastkeyin = pad
  screen.waitVblankStart()
        mf:render()
end